
package com.loafle;
import static org.junit.Assert.*;

import com.fasterxml.jackson.databind.ObjectMapper;
import com.loafle.overflow.crawler.config.*;
import com.loafle.overflow.crawler.jmx.JmxCrawler;
import com.loafle.overflow.crawler.result.OFResultSet;
import org.junit.Test;

import java.io.File;
import java.net.URL;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class AppTest {
    @Test
    public void testSum() {
        assertEquals(1,1);
    }

    @Test
    public void TestDoCrawler() throws Exception {

        ClassLoader classLoader = getClass().getClassLoader();
        URL url = classLoader.getResource("config/");
        String path = classLoader.getResource("config/example.json").getFile();

        ObjectMapper mapper = new ObjectMapper();
        Config c = mapper.readValue(new File(path),Config.class);

        JmxCrawler cr = new JmxCrawler();
        List<OFResultSet> result = (List<OFResultSet>) cr.getInternal(c);

        print("",result);

    }

    private void print(String s, List<OFResultSet> mm) {

        System.out.println(s);

        Map<String,String> m = new HashMap<>();
        for(OFResultSet r : mm) {
            m.putAll(r.getData());
        }

        for (Map.Entry<String, String> item : m.entrySet()) {
            System.out.println("key=" + item.getKey() +  " |||||||||||  value=" +  item.getValue());
        }
    }

    @Test
    public void testParseObject () {

        String s = "org.apache.catalina.mbeans.ConnectorMBean[Catalina:type=Connector,port=8080]";

        int start = s.indexOf("[");
        int end = s.lastIndexOf("]");
        s = s.substring(start + 1,end);
        assertEquals("Catalina:type=Connector,port=8080",s);
    }

}